/*
 * USE OF THE LIFEx SOFTWARE IS SUBJECT TO THE FOLLOWING TERMS AND CONDITIONS.  IF YOU DO NOT ACCEPT THESE TERMS AND CONDITIONS, DO NOT DOWNLOAD THE SOFTWARE. 
 * NON-PROFESSIONAL USERS ARE NOTIFIED THAT THE SOFTWARE AND THE RISKS INHERENT TO ITS USE, MODIFICATION AND/OR DEVELOPMENT AND REPRODUCTION ARE NOT COVERED BY ANY WARRANTY ON THE PART OF THE CEA. IT IS HIGHLY RECOMMENDED THAT YOU ONLY LOAD AND/OR USE THE SOFTWARE IF YOU HAVE SPECIALIZED IN-DEPTH INFORMATION TECHNOLOGY KNOW-HOW.
 * THE COMMISSARIAT A L’ENERGIE ATOMIQUE ET AUX ENERGIES ALTERNATIVES (FRENCH ATOMIC ENERGY AGENCY), a public scientific, technical and industrial establishment, having its registered office at 25 rue Leblanc – bâtiment le Ponant D – 75015 Paris cedex, hereinafter referred to as "CEA", hereby licenses the right to use the LIFEx software as per the terms and conditions set out below.  
 */
package bardp.protocol.protocolTexture.traditional;

import bardp.gui.FrameGui;
import bardp.raw.RawSparseZYX;
import bardp.raw.RawTZYX;
import bardp.session.patient.study.series.SeriesModel;
import bardp.utility.MessageGui;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;

/**
 *
 * @author chris
 */
public class ConventionalTraditional implements Runnable {

    public ConventionalTraditional(
            final SeriesModel seriesRaw,
            final RawTZYX rawZYX,
            final RawSparseZYX rawZYXSparse,
            final MessageGui messageGUI
    ) {
        this.seriesRaw = seriesRaw;
        this.rawZYX = rawZYX;
        this.rawZYXSparse = rawZYXSparse;
        this.messageGUI = messageGUI;
    }

    @Override
    public void run() {
        long start_time = System.currentTimeMillis();

        //<editor-fold defaultstate="collapsed" desc="convert (unit#) values into double[]">
        int count = rawZYXSparse.getSizeOfCoorList();
        double[] values = new double[count];

        Map.Entry entryZ, entryY, entryX;
        HashMap hashtableY, hashtableX;
        Iterator iteratorZ, iteratorY, iteratorX;
        int iz, iy, ix;
        int ii = 0;

        iteratorZ = rawZYXSparse.hashtableZ.entrySet().iterator();
        while (iteratorZ.hasNext()) {
            entryZ = (Map.Entry) iteratorZ.next();
            iz = (Integer) entryZ.getKey();
            hashtableY = (HashMap) entryZ.getValue();

            iteratorY = hashtableY.entrySet().iterator();
            while (iteratorY.hasNext()) {
                entryY = (Map.Entry) iteratorY.next();
                iy = (Integer) entryY.getKey();
                hashtableX = (HashMap) entryY.getValue();

                iteratorX = hashtableX.entrySet().iterator();
                while (iteratorX.hasNext()) {
                    entryX = (Map.Entry) iteratorX.next();
                    ix = (Integer) entryX.getKey();

                    values[ii++] = rawZYX.getTZYX(0, iz, iy, ix);
                }
            }
        }
        //</editor-fold>
        traditionalController = new TraditionalController(
                seriesRaw,
                rawZYX,
                rawZYXSparse
        );
        traditionalController.run(values);

        FrameGui.LOGGER.log(
                Level.INFO,
                "Time calculation of conventional indices: {0} sec",
                (System.currentTimeMillis() - start_time / 1_000d)
        );

        messageGUI.incProgress();

    }

    public TraditionalController traditionalController;
    private final RawTZYX rawZYX;
    private final RawSparseZYX rawZYXSparse;

    private final SeriesModel seriesRaw;
    private final MessageGui messageGUI;

}
